WPSGraphicShape Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Friends | List of all members
WPSGraphicShape Class Reference

a structure used to define a picture shape More...

`#include <WPSGraphicShape.h>`

## Classes
struct | PathData
| a simple path component More...

## Public Types
enum | Type { Arc, Circle, Line, Rectangle, Path, Pie, Polygon, ShapeUnknown }
| an enum used to define the shape type More...
enum | Command { C_Ellipse, C_Polyline, C_Rectangle, C_Path, C_Polygon, C_Bad }
| an enum used to define the interface command More...

## Public Member Functions
| WPSGraphicShape ()
| constructor More...
virtual | ~WPSGraphicShape ()
| virtual destructor More...
void | translate (Vec2f const &delta)
| translate all the coordinate by delta More...
void | scale (Vec2f const &factor)
| rescale all the coordinate More...
WPSGraphicShape | rotate (float angle, Vec2f const &center) const
| return a new shape corresponding to a rotation from center. More...
Type | getType () const
| returns the type corresponding to a shape More...
Box2f | getBdBox () const
| returns the basic bdbox More...
Command | addTo (Vec2f const &orig, bool asSurface, librevenge::RVNGPropertyList &propList) const
| updates the propList to send to an interface More...
int | cmp (WPSGraphicShape const &a) const
| compare two shapes More...

## Static Public Member Functions
static WPSGraphicShape | line (Vec2f const &orign, Vec2f const &dest)
| static constructor to create a line More...
static WPSGraphicShape | rectangle (Box2f const &box, Vec2f const &corners=Vec2f(0, 0))
| static constructor to create a rectangle More...
static WPSGraphicShape | circle (Box2f const &box)
| static constructor to create a circle More...
static WPSGraphicShape | arc (Box2f const &box, Box2f const &circleBox, Vec2f const &angles)
| static constructor to create a arc More...
static WPSGraphicShape | pie (Box2f const &box, Box2f const &circleBox, Vec2f const &angles)
| static constructor to create a pie More...
static WPSGraphicShape | polygon (Box2f const &box)
| static constructor to create a polygon More...
static WPSGraphicShape | path (Box2f const &box)
| static constructor to create a path More...

## Public Attributes
Type | m_type
| the type More...
Box2f | m_bdBox
| the shape bdbox More...
Box2f | m_formBox
| the internal shape bdbox ( used for arc, circle to store the circle bdbox ) More...
Vec2f | m_cornerWidth
| the rectangle round corner More...
Vec2f | m_arcAngles
| the start and end value which defines an arc More...
std::vector< Vec2f > | m_vertices
| the list of vertices for lines or polygons More...
std::vector< PathData > | m_path
| the list of path component More...
std::string | m_extra
| extra data More...

## Protected Member Functions
std::vector< PathData > | getPath () const
| return a path corresponding to the shape More...

## Friends
std::ostream & | operator<< (std::ostream &o, WPSGraphicShape const &sh)
| a print operator More...

## Detailed Description

a structure used to define a picture shape

## Member Enumeration Documentation

enum WPSGraphicShape::Command

an enum used to define the interface command

Enumerator
C_Ellipse |
C_Polyline |
C_Rectangle |
C_Path |
C_Polygon |
C_Bad |

enum WPSGraphicShape::Type

an enum used to define the shape type

Enumerator
Arc |
Circle |
Line |
Rectangle |
Path |
Pie |
Polygon |
ShapeUnknown |

## Constructor & Destructor Documentation

WPSGraphicShape::WPSGraphicShape | ( |  | ) |
| inline

constructor

virtual WPSGraphicShape::~WPSGraphicShape | ( |  | ) |
| inlinevirtual

virtual destructor

## Member Function Documentation

WPSGraphicShape::Command WPSGraphicShape::addTo | ( | Vec2f const & | orig,
|  | bool | asSurface,
|  | librevenge::RVNGPropertyList & | propList
| ) |  | const

updates the propList to send to an interface

Referenced by getBdBox(), and WKSContentListener::insertObject().

static WPSGraphicShape WPSGraphicShape::arc | ( | Box2f const & | box,
|  | Box2f const & | circleBox,
|  | Vec2f const & | angles
| ) |  |
| inlinestatic

static constructor to create a arc

Referenced by LotusGraphInternal::Zone::getGraphicShape().

static WPSGraphicShape WPSGraphicShape::circle | ( | Box2f const & | box | ) |
| inlinestatic

static constructor to create a circle

Referenced by LotusGraphInternal::Zone::getGraphicShape().

int WPSGraphicShape::cmp | ( | WPSGraphicShape const & | a | ) | const

compare two shapes

Box2f WPSGraphicShape::getBdBox | ( |  | ) | const
| inline

returns the basic bdbox

std::vector< WPSGraphicShape::PathData > WPSGraphicShape::getPath | ( |  | ) | const
| protected

return a path corresponding to the shape

Referenced by getBdBox(), and rotate().

Type WPSGraphicShape::getType | ( |  | ) | const
| inline

returns the type corresponding to a shape

Referenced by WKSContentListener::insertObject().

WPSGraphicShape WPSGraphicShape::line | ( | Vec2f const & | orign,
|  | Vec2f const & | dest
| ) |  |
| static

static constructor to create a line

Referenced by LotusGraphInternal::Zone::getGraphicShape(), and ~WPSGraphicShape().

static WPSGraphicShape WPSGraphicShape::path | ( | Box2f const & | box | ) |
| inlinestatic

static constructor to create a path

Referenced by WPSGraphicShape::PathData::PathData(), and rotate().

static WPSGraphicShape WPSGraphicShape::pie | ( | Box2f const & | box,
|  | Box2f const & | circleBox,
|  | Vec2f const & | angles
| ) |  |
| inlinestatic

static constructor to create a pie

static WPSGraphicShape WPSGraphicShape::polygon | ( | Box2f const & | box | ) |
| inlinestatic

static constructor to create a polygon

static WPSGraphicShape WPSGraphicShape::rectangle | ( | Box2f const & | box,
|  | Vec2f const & | corners = `Vec2f(0,0)`
| ) |  |
| inlinestatic

static constructor to create a rectangle

Referenced by LotusGraphInternal::Zone::getGraphicShape().

WPSGraphicShape WPSGraphicShape::rotate | ( | float | angle,
|  | Vec2f const & | center
| ) |  | const

return a new shape corresponding to a rotation from center.

Note
  the final bdbox is not tight

void WPSGraphicShape::scale | ( | Vec2f const & | factor | ) |

rescale all the coordinate

void WPSGraphicShape::translate | ( | Vec2f const & | delta | ) |

translate all the coordinate by delta

## Friends And Related Function Documentation

std::ostream& operator<< | ( | std::ostream & | o,
|  | WPSGraphicShape const & | sh
| ) |  |
| friend

a print operator

## Member Data Documentation

Vec2f WPSGraphicShape::m_arcAngles

the start and end value which defines an arc

Referenced by addTo(), arc(), cmp(), getPath(), operator<<(), and pie().

Box2f WPSGraphicShape::m_bdBox

the shape bdbox

Referenced by addTo(), arc(), circle(), cmp(), getBdBox(), line(), operator<<(), path(), pie(), polygon(), rectangle(), rotate(), scale(), and translate().

Vec2f WPSGraphicShape::m_cornerWidth

the rectangle round corner

Referenced by addTo(), cmp(), getPath(), operator<<(), and rectangle().

std::string WPSGraphicShape::m_extra

extra data

Referenced by operator<<().

Box2f WPSGraphicShape::m_formBox

the internal shape bdbox ( used for arc, circle to store the circle bdbox )

Referenced by addTo(), arc(), circle(), cmp(), getPath(), operator<<(), pie(), rectangle(), scale(), and translate().

std::vector<PathData> WPSGraphicShape::m_path

the list of path component

Referenced by addTo(), cmp(), getPath(), operator<<(), rotate(), scale(), and translate().

Type WPSGraphicShape::m_type

the type

Referenced by arc(), circle(), cmp(), line(), operator<<(), path(), pie(), polygon(), and rectangle().

std::vector<Vec2f> WPSGraphicShape::m_vertices

the list of vertices for lines or polygons

Referenced by addTo(), cmp(), getPath(), line(), operator<<(), scale(), and translate().

The documentation for this class was generated from the following files:

- WPSGraphicShape.h
- WPSGraphicShape.cpp